app/models/concerns/orchestration/compute.rb:93 rescue ends up with error (ArgumentError): too

few arguments
Status: Closed   
Assignee:    
Description

Here is the complete stacktrace:

2021-04-08T15:20:19 [I|app|30891307] Backtrace for 'Caught VMware error' error (Fog::Vsphere::Comp

ute::NotFound): Datastore  Doesn't Exist!

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/fog-vsphere-3.4.0/lib/fog/vsphere/request

s/compute/vm_clone.rb:28:in `vm_clone_check_options'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/fog-vsphere-3.4.0/lib/fog/vsphere/request

s/compute/vm_clone.rb:105:in `vm_clone'

 30891307 | /usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:567:in `clone_

vm'

 30891307 | /usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:485:in `create

_vm'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration/compute.rb:91:in `setCompute'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:227:in `execute'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:152:in `block in process'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:144:in `each'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:144:in `process'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:44:in `around_save_orchestrati

on'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:139:in `run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:825:in `_run_save_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/ca

llbacks.rb:327:in `create_or_update'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/ti

mestamp.rb:128:in `create_or_update'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/pe

rsistence.rb:470:in `save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/va

lidations.rb:47:in `save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:314:in `block in save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:375:in `block in with_transaction_returning_status'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/database_statements.rb:280:in `block in transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/transaction.rb:280:in `block in within_new_transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:26:in `block (2 levels) in synchronize'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/
concurrency/load_interlock_aware_monitor.rb:25:in `handle_interrupt'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:25:in `block in synchronize'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:21:in `handle_interrupt'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:21:in `synchronize'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/transaction.rb:278:in `within_new_transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/database_statements.rb:280:in `transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:212:in `transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:366:in `with_transaction_returning_status'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:314:in `save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/su

ppressor.rb:44:in `save'

 30891307 | /usr/share/foreman/app/models/concerns/foreman/sti.rb:26:in `save'

 30891307 | /usr/share/foreman/app/controllers/hosts_controller.rb:98:in `create'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/basic_implicit_render.rb:6:in `send_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/base.rb:195:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/rendering.rb:30:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/callbacks.rb:42:in `block in process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:112:in `block in run_callbacks'

 30891307 | /usr/share/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:in `set_

timezone'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in

 `set_topbar_sweeper_controller'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/lib/audited/sweeper.rb:14:i

n `around'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/lib/audited/sweeper.rb:14:i

n `around'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:139:in `run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/callbacks.rb:41:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/rescue.rb:22:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/instrumentation.rb:33:in `block in process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

notifications.rb:180:in `block in instrument'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

notifications/instrumenter.rb:24:in `instrument'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

notifications.rb:180:in `instrument'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/instrumentation.rb:32:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/
metal/params_wrapper.rb:245:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/ra

ilties/controller_runtime.rb:27:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/base.rb:136:in `process'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionview-6.0.3.4/lib/action_view/render

ing.rb:39:in `process'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal.rb:190:in `dispatch'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal.rb:254:in `dispatch'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ro

uting/route_set.rb:50:in `dispatch'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ro

uting/route_set.rb:33:in `serve'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/jo

urney/router.rb:49:in `block in serve'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/jo

urney/router.rb:32:in `each'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/jo

urney/router.rb:32:in `serve'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ro

uting/route_set.rb:834:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-dsl-2.3.0/lib/apipie_dsl/static_di

spatcher.rb:67:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/lib/apipie/static_dis

patcher.rb:66:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/lib/apipie/extractor/

recorder.rb:137:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/telemetry.rb:10:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/lib/apipie/middleware

/checksum_in_headers.rb:27:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/tempfile_reaper.rb:15

:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/etag.rb:27:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/conditional_get.rb:40

:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/head.rb:12:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ht

tp/content_security_policy.rb:18:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/logging_context_session.rb:22:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/session/abstract/id.r

b:266:in `context'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/session/abstract/id.r

b:260:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/cookies.rb:648:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/callbacks.rb:27:in `block in call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:101:in `run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/callbacks.rb:26:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/actionable_exceptions.rb:18:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/debug_exceptions.rb:32:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/show_exceptions.rb:33:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/rack/logger.rb
:37:in `call_app'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/rack/logger.rb

:28:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/sprockets-rails-3.2.1/lib/sprockets/rails

/quiet_assets.rb:13:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/logging_context_request.rb:11:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/remote_ip.rb:81:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/request_id.rb:27:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/method_override.rb:24

:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/runtime.rb:22:in `cal

l'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

cache/strategy/local_cache_middleware.rb:29:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/executor.rb:14:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/sendfile.rb:110:in `c

all'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/host_authorization.rb:76:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/secure_headers-6.3.0/lib/secure_headers/m

iddleware.rb:11:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/engine.rb:527:

in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/railtie.rb:190

:in `public_send'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/railtie.rb:190

:in `method_missing'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/urlmap.rb:74:in `bloc

k in call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/urlmap.rb:58:in `each

'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/urlmap.rb:58:in `call

'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/configuration.rb:228:

in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/server.rb:713:in `han

dle_request'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/server.rb:472:in `pro

cess_client'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/server.rb:328:in `blo

ck in run'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/thread_pool.rb:134:in

 `block in spawn_thread'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/logging-2.3.0/lib/logging/diagnostic_cont

ext.rb:474:in `block in create_with_logging_context'

2021-04-08T15:20:19 [W|app|30891307] Set up compute instance test-rtsp-simple-server.production.do

main.com task failed with the following error: too few arguments

2021-04-08T15:20:19 [I|app|30891307] Backtrace for 'Set up compute instance test-rtsp-simple-serve

r.production.domain.com task failed with the following error: too few arguments' error (ArgumentEr

ror): too few arguments

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/fast_gettext-1.4.1/lib/fast_gettext/vendo

r/string.rb:70:in `%'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/fast_gettext-1.4.1/lib/fast_gettext/vendo

r/string.rb:70:in `%'

 30891307 | /usr/share/foreman/lib/foreman/exception.rb:28:in `message'

 30891307 | /usr/share/foreman/lib/foreman/exception.rb:58:in `message'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration/compute.rb:93:in `rescue in setCo

mpute'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration/compute.rb:82:in `setCompute'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:227:in `execute'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:152:in `block in process'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:144:in `each'
 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:144:in `process'

 30891307 | /usr/share/foreman/app/models/concerns/orchestration.rb:44:in `around_save_orchestrati

on'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:139:in `run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:825:in `_run_save_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/ca

llbacks.rb:327:in `create_or_update'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/ti

mestamp.rb:128:in `create_or_update'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/pe

rsistence.rb:470:in `save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/va

lidations.rb:47:in `save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:314:in `block in save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:375:in `block in with_transaction_returning_status'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/database_statements.rb:280:in `block in transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/transaction.rb:280:in `block in within_new_transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:26:in `block (2 levels) in synchronize'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:25:in `handle_interrupt'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:25:in `block in synchronize'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:21:in `handle_interrupt'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

concurrency/load_interlock_aware_monitor.rb:21:in `synchronize'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/transaction.rb:278:in `within_new_transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/co

nnection_adapters/abstract/database_statements.rb:280:in `transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:212:in `transaction'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:366:in `with_transaction_returning_status'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/tr

ansactions.rb:314:in `save'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/su

ppressor.rb:44:in `save'

 30891307 | /usr/share/foreman/app/models/concerns/foreman/sti.rb:26:in `save'

 30891307 | /usr/share/foreman/app/controllers/hosts_controller.rb:98:in `create'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/basic_implicit_render.rb:6:in `send_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/base.rb:195:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/rendering.rb:30:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/callbacks.rb:42:in `block in process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:112:in `block in run_callbacks'

 30891307 | /usr/share/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:in `set_

timezone'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in
 `set_topbar_sweeper_controller'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/lib/audited/sweeper.rb:14:i

n `around'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/lib/audited/sweeper.rb:14:i

n `around'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:121:in `block in run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:139:in `run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/callbacks.rb:41:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/rescue.rb:22:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/instrumentation.rb:33:in `block in process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

notifications.rb:180:in `block in instrument'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

notifications/instrumenter.rb:24:in `instrument'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

notifications.rb:180:in `instrument'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/instrumentation.rb:32:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal/params_wrapper.rb:245:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.4/lib/active_record/ra

ilties/controller_runtime.rb:27:in `process_action'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/abstract_controlle

r/base.rb:136:in `process'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionview-6.0.3.4/lib/action_view/render

ing.rb:39:in `process'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal.rb:190:in `dispatch'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_controller/

metal.rb:254:in `dispatch'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ro

uting/route_set.rb:50:in `dispatch'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ro

uting/route_set.rb:33:in `serve'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/jo

urney/router.rb:49:in `block in serve'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/jo

urney/router.rb:32:in `each'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/jo

urney/router.rb:32:in `serve'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ro

uting/route_set.rb:834:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-dsl-2.3.0/lib/apipie_dsl/static_di

spatcher.rb:67:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/lib/apipie/static_dis

patcher.rb:66:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/lib/apipie/extractor/

recorder.rb:137:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/telemetry.rb:10:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/lib/apipie/middleware

/checksum_in_headers.rb:27:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in `call'
 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/tempfile_reaper.rb:15

:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/etag.rb:27:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/conditional_get.rb:40

:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/head.rb:12:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/ht

tp/content_security_policy.rb:18:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/logging_context_session.rb:22:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/session/abstract/id.r

b:266:in `context'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/session/abstract/id.r

b:260:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/cookies.rb:648:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/callbacks.rb:27:in `block in call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

callbacks.rb:101:in `run_callbacks'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/callbacks.rb:26:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/actionable_exceptions.rb:18:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/debug_exceptions.rb:32:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/show_exceptions.rb:33:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/rack/logger.rb

:37:in `call_app'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/rack/logger.rb

:28:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/sprockets-rails-3.2.1/lib/sprockets/rails

/quiet_assets.rb:13:in `call'

 30891307 | /usr/share/foreman/lib/foreman/middleware/logging_context_request.rb:11:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/remote_ip.rb:81:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/request_id.rb:27:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/method_override.rb:24

:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/runtime.rb:22:in `cal

l'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.4/lib/active_support/

cache/strategy/local_cache_middleware.rb:29:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/executor.rb:14:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/static.rb:126:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/sendfile.rb:110:in `c

all'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.4/lib/action_dispatch/mi

ddleware/host_authorization.rb:76:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/secure_headers-6.3.0/lib/secure_headers/m

iddleware.rb:11:in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/engine.rb:527:

in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/railtie.rb:190

:in `public_send'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.4/lib/rails/railtie.rb:190

:in `method_missing'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/urlmap.rb:74:in `bloc

k in call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/urlmap.rb:58:in `each

'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/lib/rack/urlmap.rb:58:in `call

'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/configuration.rb:228:
in `call'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/server.rb:713:in `han

dle_request'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/server.rb:472:in `pro

cess_client'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/server.rb:328:in `blo

ck in run'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/puma-4.3.6/lib/puma/thread_pool.rb:134:in

 `block in spawn_thread'

 30891307 | /opt/theforeman/tfm/root/usr/share/gems/gems/logging-2.3.0/lib/logging/diagnostic_cont

ext.rb:474:in `block in create_with_logging_context'

 Tried on IRC with ewoud to fix it but we did not manage. It seems the only things that works is remove additional exception AND all

arguments in error message, which does not make any sense.

I managed to raise this error by creating an undeployable host (Storage not available on selected ESX cluster)

Associated revisions

Revision bf8544a9 - 09/14/2021 01:41 PM - Adam Cécile

Fixes #32273 - VMWare compute failure ends up in ArgumentError (too few arguments)

History

#1 - 05/28/2021 08:15 AM - Adam Cécile

- Found in Releases 2.4.0 added

Actually I think the error is in Foreman exception class itself, here:

 6dfe8627 | /opt/theforeman/tfm/root/usr/share/gems/gems/fast_gettext-1.4.1/lib/fast_gettext/vendor/string.rb:

70:in `%'

 6dfe8627 | /opt/theforeman/tfm/root/usr/share/gems/gems/fast_gettext-1.4.1/lib/fast_gettext/vendor/string.rb:

70:in `%'

 6dfe8627 | /usr/share/foreman/lib/foreman/exception.rb:28:in `message'

 6dfe8627 | /usr/share/foreman/lib/foreman/exception.rb:58:in `message'

 It's working fine until I tried to print e.message.

The real exception is:

2021-05-28T10:09:36 [I|app|6dfe8627] Backtrace for 'Caught VMware error' error (Fog::Vsphere::Compute::NotFoun

d): Datastore  Doesn't Exist!

 So I think I might getting close to the root of the issue, see the double space after Datastore ? I'm thinking this string may also contains a placeholder

or something and resolves to nil.

#2 - 05/28/2021 08:32 AM - Adam Cécile

So here is a quick patch, now it logs this:

2021-05-28T10:29:45 [W|app|ce6aabb3] Got ArgumentError when accessing Foreman::WrappedException message attrib

ute, falling back to message_untranslated containing Foreman could not find a required vSphere resource. Check

 if Foreman has the required permissions and the resource exists. Reason: %s

 New code:

    # Workaround bug when the exception itself contains unresolved string placeholder

    

# Example: Foreman could not find a required vSphere resource. Check if Foreman has the required permissions a

nd the resource exists. Reason: %s

    # See: https://projects.theforeman.org/issues/32273

    begin

      failure _("Failed to create a compute %{compute_resource} instance %{name}: %{message}\n ") % { 

:compute_resource => compute_resource, :name => name, :message => e.message }, e

    rescue => e2

      logger.warn "Got #{e2.class} when accessing #{e.class}

 message attribute, falling back to message_untranslated containing #{e.message_untranslated}" 

      failure _("Failed to create a compute %{compute_resource} instance %{name}: %{message}\n ") % { 

:compute_resource => compute_resource, :name => name, :message => e.message_untranslated }
    end

 The issue definitely comes from Foreman::WrappedException which contains unresolved %s placeholder but I'm not sure why, but I do think

hardened exception handling here makes sense as I'm not the only reporting too few arguments error here.

#3 - 05/28/2021 08:37 AM - Adam Cécile

And I just found the original root issue, preparing PR.

#4 - 05/28/2021 08:49 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/8556 added

#5 - 09/10/2021 01:23 AM - The Foreman Bot

- Status changed from Ready For Testing to New

- Pull request deleted (https://github.com/theforeman/foreman/pull/8556)

#6 - 09/14/2021 08:43 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/8556 added

#7 - 09/14/2021 01:41 PM - The Foreman Bot

- Fixed in Releases 3.2.0 added

#8 - 09/14/2021 02:08 PM - Adam Cécile

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|bf8544a91dc29e4f509ce7c5b1688136645ba9dc.

#9 - 09/15/2021 01:59 PM - Ondřej Ezr

- Fixed in Releases 3.0.1, 3.1.0 added

- Fixed in Releases deleted (3.2.0)

#10 - 11/15/2021 04:53 PM - Amit Upadhye

- Category set to Compute resources - VMware
